#!/usr/bin/perl -w

use Ivy;
use strict;


# =================

$SIG {'INT'}='INT_handler';

my $bus = "127.0.0.255:2010";

Ivy->init (-loopMode => 'LOCAL', -appName => "greco2ppt", -ivyBus => $bus);

my $ivy = Ivy->new (-ivyBus => $bus, -appName => "greco2ppt");
$ivy->start;

#open a new file

open (MYFILE, ">>greco_session.txt") || die "Problme d'ouverture du fichier de log";
print MYFILE "_____________________\n";

# Subscribes all regexp
$ivy->bindRegexp("^Greco Gesture=(.*)",[\&CB_Todo]);
$ivy->bindRegexp("^SRAP Parse=(.*)",[\&CB_TodoReco]);
#$ivy->after (3000, \&CB_After);

$ivy->mainLoop;
close MYFILE;

sub CB_After {
  print "Message envoy\n"; 
  $ivy->sendMsgs ("Bye");
}

sub CB_Todo {
   my $action= " ";
   my $self = shift; # le nom de l'appli
   my $received = shift; # les arguments au complet ...
   print MYFILE  "Gesture:  $received \n";
   if ($received eq "up") {
	$action= "Launch";
	}
   elsif ($received eq "right")
		{
			$action = "Next";
		}
 elsif ($received eq "left")
		{
			$action = "Previous";
		}
 elsif ($received eq "down")
		{
			$action = "EndShow";
		}
 elsif ($received eq "zigzag")
		{
			$action = "Quit";
		}
   elsif ($received eq "wave")
		{
			$action = "New";
		}
  if (!($action eq '')  )
	{
	  $ivy->sendMsgs("IMM Action=$action ");
	  $ivy->sendMsgs("TTS Say=$action ");
	   print MYFILE  "Action :  $action \n\n";
	}


}

# Speech Recognition

sub CB_TodoReco {
   my $action= " ";
   my $self = shift; # le nom de l'appli
   my $received = shift; # les arguments au complet ...
   print MYFILE  "Speech:  $received \n";
   if ($received eq "Next")
	 {
	$action= "Next";
	}
   elsif ($received eq "Previous")
	{
		$action = "Previous";
	}
   elsif ($received eq "Launch")
	{
		$action = "Launch";
	}
   elsif ($received eq "Quit")
	{
		$action = "Quit";
	}
   elsif ($received eq "New")
	{
		$action = "New";
	}
  if (!($action eq '')  )
	{
	  $ivy->sendMsgs("IMM Action=$action ");
	   print MYFILE  "Action :  $action \n\n";
	}
}

sub INT_handler {
 close MYFILE;
 exit(0);
}